
*****************************************************************************
*
*	'getarg' is a subroutine which returns a command line argument
*	in a CHARACTER dummy argument for Absoft FORTRAN.
*
*	INPUTS
*		arg_num		The argument asked for
*		argument	CHARACTER variable to return the argument in
*	OUTPUTS
*		Sets 'argument' to the command line argument 'arg_num' or
*		to all blanks if there was no command line argument given.
*
*	NOTE:	If the main program is not written in Absoft FORTRAN,
*		this subroutine will not work.
*
*****************************************************************************

	SUBROUTINE getarg(arg_num,argument)

! Dummy arguments

	INTEGER*4 arg_num		! argument position
	CHARACTER*(*) argument		! string returned

! Globals passed in from the system

	INTEGER*4 argc				    ! total number of arguments
	INTEGER*4 C_string_pointers(0:z'7fffffff')  ! array of pointers
	POINTER (argv,C_string_pointers)	    ! handle to array
	INTEGER*4 environ			    ! pointer to environment
	COMMON /ABSOFT__ARGS/ argc, argv, environ   ! initialized in MAIN

! Locals used for copying the argument

	CHARACTER the_arg(z'7fffffff')		 ! to index the C string
	POINTER (arg_pointer, the_arg)

	argument = ' '				 ! initialize return value

	IF (arg_num >= argc) RETURN		 ! not that many args

	arg_pointer = C_string_pointers(arg_num) ! grab the argument

!   Copy the argument

	DO i=1, LEN(argument)
		if (the_arg(i) == CHAR(0)) EXIT
		argument(i:i) = the_arg(i)
	END DO

	RETURN
	END

******************************************************************************
*
*	'iargc' is an INTEGER*4 function wich returns the number of arguments
*	which were typed on the command line when a program was started.
*
*	INPUTS
*		None
*	OUTPUTS
*		Returns the number of arguments in the command line
*
*	NOTE:	This function will not work if the main program was not
*		written in Absoft FORTRAN.
*
*****************************************************************************

	INTEGER FUNCTION iargc()

	INTEGER*4 argc				   ! total number of arguments
	INTEGER*4 argv				   ! handle to array
	INTEGER*4 environ			   ! pointer to environment
	COMMON /ABSOFT__ARGS/ argc, argv, environ  ! initialized in MAIN

	iargc = argc - 1
	RETURN
	END

