**==PROBES.F
************************************************************************
*  Copyright (c) Polyhedron Software Ltd. (1993) - All rights reserved.*
************************************************************************
      SUBROUTINE UDZI1(I1var)
C
C  Undefine an INTEGER*1 variable
C  (ENTRYs for BYTE and LOGICAL*1)
C
      IMPLICIT NONE
      ENTRY UDZB1(I1var)
      ENTRY UDZL1(I1var)
*-IF VAXVMS,UNIX
      BYTE I1var
*-ELSE
*-      INTEGER*1 I1var
*-ENDIF
      INCLUDE 'probes.prv'
 
      I1var = I1UNDF
      END
 
      SUBROUTINE UDZI2(I2var)
C
C  Undefine an INTEGER*2 variable
C  (ENTRY for LOGICAL*2)
C
      IMPLICIT NONE
      ENTRY UDZL2(I2var)
      INTEGER*2 I2var
      INCLUDE 'probes.prv'
 
      I2var = I2UNDF
      END
 
      SUBROUTINE UDZI4(I4var)
C
C  Undefine an INTEGER*4 variable
C  (ENTRYs for LOGICAL*4 and REAL*4)
C
      IMPLICIT NONE
      ENTRY UDZL4(I4var)
      ENTRY UDZR4(I4var)
      INTEGER*4 I4var
      INCLUDE 'probes.prv'
 
      I4var = I4UNDF
      END
 
      SUBROUTINE UDZR8(R8var)
C
C  Undefine a REAL*8 variable
C  (ENTRYs for DOUBLE PRECISION, COMPLEX*8 and INTEGER*8)
C
      IMPLICIT NONE
      ENTRY UDZD8(R8var)
      ENTRY UDZX8(R8var)
      ENTRY UDZI8(R8var)
      INTEGER*4 R8var(2)
      INCLUDE 'probes.prv'
 
      R8var(1) = I4UNDF
      R8var(2) = I4UNDF
      END
 
      SUBROUTINE UDZ16(C16va)
C
C  Undefine a COMPLEX*16 variable
C
      IMPLICIT NONE
      INTEGER*4 C16va(*)
      INCLUDE 'probes.prv'
 
      C16va(1) = I4UNDF
      C16va(2) = I4UNDF
      C16va(3) = I4UNDF
      C16va(4) = I4UNDF
      END
 
      SUBROUTINE UDZCH(Chvar)
C
C  Undefine a CHARACTER*(*) variable
C
      IMPLICIT NONE
      CHARACTER*(*) Chvar
      INCLUDE 'probes.prv'
      INTEGER j
 
      DO j = 1 , LEN(Chvar)
         Chvar(j:j) = CHAR(128)
      ENDDO
      END
 
      SUBROUTINE UDZAI1(Nel,I1arr)
C
C  Undefine an array of INTEGER*1 
C  (ENTRYs for BYTE and LOGICAL*1)
C
      IMPLICIT NONE
      ENTRY UDZAB1(Nel,I1arr)
      ENTRY UDZAL1(Nel,I1arr)
      INTEGER Nel
*-IF VAXVMS,UNIX
      BYTE I1arr(Nel)
*-ELSE
*-      INTEGER*1 I1arr(Nel)
*-ENDIF
      INCLUDE 'probes.prv'
      INTEGER i
 
      DO 10 i = 1 , Nel
         I1arr(i) = I1UNDF
 10   CONTINUE
      END
 
      SUBROUTINE UDZAI2(Nel,I2arr)
C
C  Undefine an array of INTEGER*2
C  (ENTRY for LOGICAL*2)
C
      IMPLICIT NONE
      ENTRY UDZAL2(Nel,I2arr)
      INTEGER Nel
      INTEGER*2 I2arr(Nel)
      INCLUDE 'probes.prv'
      INTEGER i
 
      DO 10 i = 1 , Nel
         I2arr(i) = I2UNDF
 10   CONTINUE
      END
 
      SUBROUTINE UDZAI4(Nel,I4arr)
C
C  Undefine an array of INTEGER*4 
C  (ENTRYs for REAL*4 and LOGICAL*4)
C
      IMPLICIT NONE
      ENTRY UDZAL4(Nel,I4arr)
      ENTRY UDZAR4(Nel,I4arr)
      INTEGER Nel
      INTEGER*4 I4arr(Nel)
      INCLUDE 'probes.prv'
      INTEGER i
 
      DO 10 i = 1 , Nel
         I4arr(i) = I4UNDF
 10   CONTINUE
      END
 
      SUBROUTINE UDZAR8(Nel,R8arr)
C
C  Undefine an array of REAL*8
C  (ENTRYs for DOUBLE PRECISION, COMPLEX*8 and INTEGER*8)
C
      IMPLICIT NONE
      ENTRY UDZAD8(Nel,R8arr)
      ENTRY UDZAX8(Nel,R8arr)
      ENTRY UDZAI8(Nel,R8arr)
      INTEGER Nel
      INTEGER*4 R8arr(*)
      INCLUDE 'probes.prv'
      INTEGER i
 
      DO 10 i = 1 , 2*Nel
         R8arr(i) = I4UNDF
 10   CONTINUE
      END
 
      SUBROUTINE UDZA16(Nel,C16ar)
C
C  Undefine an array of COMPLEX*16
C
      IMPLICIT NONE
      INTEGER Nel
      INTEGER*4 C16ar(*)
      INCLUDE 'probes.prv'
      INTEGER i
 
      DO 10 i = 1 , 4*Nel
         C16ar(i) = I4UNDF
 10   CONTINUE
      END
 
      SUBROUTINE UDZACH(Nel,Charr)
C
C  Undefine an array of CHARACTER*(*)
C
      IMPLICIT NONE
      INTEGER Nel
      CHARACTER*(*) Charr(Nel)
      INCLUDE 'probes.prv'
      INTEGER i , j
 
      DO i = 1 , Nel
         DO j = 1 , LEN(Charr(1))
            Charr(i)(j:j) = CHAR(128)
         ENDDO
      ENDDO
      END
 
      SUBROUTINE QDZI1(Zname,I1var,Lnum)
C
C  Check that an INTEGER*1 item is defined.  If it is not, log and error
C  and set it to zero.
C  (ENTRYs for LOGICAL*1 and BYTE)
C
      IMPLICIT NONE
      ENTRY QDZL1(Zname,I1var,Lnum)
      ENTRY QDZB1(Zname,I1var,Lnum)
      CHARACTER*(*) Zname
      INTEGER Lnum
*-IF VAXVMS,UNIX
      BYTE I1var
*-ELSE
*-      INTEGER*1 I1var
*-ENDIF
      INCLUDE 'probes.prv'
      LINnum(LVNest) = Lnum
      IF ( I1var.EQ.I1UNDF ) THEN
         CALL RPZNDF(Zname)
         I1var = 0
      ENDIF
      END
 
      SUBROUTINE QDZI2(Zname,I2var,Lnum)
C
C  Check that an INTEGER*2 item is defined.  If it is not, log and error
C  and set it to zero.
C  (ENTRY for LOGICAL*2)
C
      IMPLICIT NONE
      ENTRY QDZL2(Zname,I2var,Lnum)
      CHARACTER*(*) Zname
      INTEGER Lnum
      INTEGER*2 I2var
      INCLUDE 'probes.prv'
      LINnum(LVNest) = Lnum
      IF ( I2var.EQ.I2UNDF ) THEN
         CALL RPZNDF(Zname)
         I2var = 0
      ENDIF
      END
 
      SUBROUTINE QDZI4(Zname,I4var,Lnum)
C
C  Check that an INTEGER*4 item is defined.  If it is not, log and error
C  and set it to zero.
C  (ENTRYs for LOGICAL*4 and REAL*4)
C
      IMPLICIT NONE
      ENTRY QDZL4(Zname,I4var,Lnum)
      ENTRY QDZR4(Zname,I4var,Lnum)
      CHARACTER*(*) Zname
      INTEGER Lnum
      INTEGER*4 I4var
      INCLUDE 'probes.prv'
      LINnum(LVNest) = Lnum
      IF ( I4var.EQ.I4UNDF ) THEN
         CALL RPZNDF(Zname)
         I4var = 0
      ENDIF
      END
 
      SUBROUTINE QDZR8(Zname,R8var,Lnum)
C
C  Check that a REAL*8 item is defined.  If it is not, log and error
C  and set it to zero.
C  (ENTRYs for DOUBLE PRECISION, COMPLEX*8 and INTEGER*8)
C
      IMPLICIT NONE
      ENTRY QDZD8(Zname,R8var,Lnum)
      ENTRY QDZX8(Zname,R8var,Lnum)
      ENTRY QDZI8(Zname,R8var,Lnum)
      CHARACTER*(*) Zname
      INTEGER Lnum
      INTEGER*4 R8var(2)
      INCLUDE 'probes.prv'
      LINnum(LVNest) = Lnum
      IF ( R8var(1).EQ.I4UNDF .OR.
     &     R8var(2).EQ.I4UNDF      ) THEN
         CALL RPZNDF(Zname)
         R8var(1) = 0
         R8var(2) = 0
      ENDIF
      END
 
      SUBROUTINE QDZ16(Zname,C16va,Lnum)
C
C  Check that a COMPLEX*16 item is defined.  If it is not, log and error
C  and set it to zero.
C
      IMPLICIT NONE
      CHARACTER*(*) Zname
      INTEGER Lnum
      INTEGER*4 C16va(4)
      INCLUDE 'probes.prv'
      LINnum(LVNest) = Lnum
      IF ( C16va(1).EQ.I4UNDF .OR.
     &     C16va(2).EQ.I4UNDF .OR.
     &     C16va(3).EQ.I4UNDF .OR.
     &     C16va(4).EQ.I4UNDF      ) THEN
         CALL RPZNDF(Zname)
         C16va(1) = 0
         C16va(2) = 0
         C16va(3) = 0
         C16va(4) = 0
      ENDIF
      END
 
      SUBROUTINE QDZCH(Zname,Chvar,Lnum)
C
C  Check that a CHARACTER item is defined.  If it is not, log and error
C  and fill it with spaces.
C
      IMPLICIT NONE
      CHARACTER*(*) Zname , Chvar
      INTEGER Lnum
      INCLUDE 'probes.prv'
      INTEGER i
      LINnum(LVNest) = Lnum
      DO i = 1 , LEN(Chvar)
         IF ( Chvar(i:i).NE.CHAR(128) ) GOTO 99999
      ENDDO
      IF ( LEN(Chvar).GT.1 ) THEN
         CALL RPZNDF(Zname)
         Chvar = ' '
      ENDIF
99999 END
 
      SUBROUTINE QDZLNM(Lnum)
C
C  Just record the current line number (before a call)
C  QDZLNM is called just before a CALL which has no other probes in 
C  front of it - to make trace-backs more accurate
C
      IMPLICIT NONE
      INTEGER Lnum
      INCLUDE 'probes.prv'
      LINnum(LVNest) = Lnum
      END
 
      SUBROUTINE RPZNDF(Zname)
C
C  Report an undefined variable called Zname, complete with traceback
C  of active routines
C
      IMPLICIT NONE
      CHARACTER*(*) Zname
      INCLUDE 'probes.prv'
      INTEGER i
 
      WRITE(LOGUNI,*) Zname ,' value is undefined'
      DO i = LVNest , 1 , -1
         IF ( LSUbpr(i).GT.8 ) THEN
            WRITE(LOGUNI,'(1X,A20,A6,I6,A6,A)')
     &               ZSUbpr(i)(1:LSUbpr(i)) ,
     &               ' line ' , LINnum(i) ,
     &               ' file ' , ZFIlna(i)(1:LFIlna(i))
         ELSE
            WRITE(LOGUNI,'(A13,A8,A6,I6,A6,A)')
     &               '  subprogram ' , ZSUbpr(i)(1:LSUbpr(i)) ,
     &               ' line ' , LINnum(i) ,
     &               ' file ' , ZFIlna(i)(1:LFIlna(i))
         ENDIF
      ENDDO
      WRITE(LOGUNI,*)
      END
 
      SUBROUTINE PRZENT(Zsub,Zfile,Zcvdi)
C
C  Called on entry to a program - initiallises probes
C  Zsub  is the program name
C  Zfile is the name of the file containing the source code
C  Zcvdi is the name of the directory containing coverage data
C        set to ' ' if coverage analysis is not active
C
      IMPLICIT NONE
      CHARACTER*(*) Zsub , Zfile , Zcvdi
      INCLUDE 'probes.prv'
      INTEGER slot
      LOGICAL qnew
 
      OPEN(LOGUNI,FILE='PROBES.LOG',STATUS='UNKNOWN')
      ZCVdir = Zcvdi
      CALL CVZINIT
      CALL CVZSLOT(Zsub,slot,qnew)
      IF ( qnew .AND. ZCVdir(1:1).NE.' ' ) CALL CVZREAD(Zfile)
      CURbas = LINbas(slot)
      LVNest = 1
      LSUbpr(LVNest) = LEN(Zsub)
      ZSUbpr(LVNest)(1:LEN(Zsub)) = Zsub
      LFIlna(LVNest) = LEN(Zfile)
      ZFIlna(LVNest)(1:LEN(Zfile)) = Zfile
      LINnum(LVNest) =-1
      OFFset(LVNest) = CURbas
*-IF CLOCKS
*-      CALL CKZINI
*-      CALL CKZON(slot)
*-ENDIF
      END
 
      SUBROUTINE SBZENT2(Zsub,Zfile)
C
C  Called immediately after every ENTRY statement in a sub-program
C
C  Zsub  is the sub-program name
C  Zfile is the name of the file containing the source code
C
C  If Zsub is the same as the subprogram name at the current nesting 
C  level, then nothing is done because control must have reached
C  this point by dropping through from above.  If the subprogram name
C  is changed, then the ENTRY was CALLed and the nesting must be 
C  updated by a call to SBZENT.
C
C  Note that if a subroutine calls an entry point in itself recursively
C  SPAG will report an error and not produce dynamic analysis output.
C
      IMPLICIT NONE
      CHARACTER*(*) Zsub , Zfile
      INCLUDE 'probes.prv'
      IF ( ZSUbpr(LVNest)(1:LSUbpr(LVNest)).NE.Zsub )
     &            CALL SBZENT(Zsub,Zfile)
      END
 
      SUBROUTINE SBZENT(Zsub,Zfile)
C
C  Called immediately before the first executable statement of a 
C      sub-program - updates trace data
C  Zsub  is the sub-program name
C  Zfile is the name of the file containing the source code
C
      IMPLICIT NONE
      CHARACTER*(*) Zsub , Zfile
      INCLUDE 'probes.prv'
      INTEGER i , slot
      LOGICAL qnew
 
      CALL CVZSLOT(Zsub,slot,qnew)
      IF ( qnew .AND. ZCVdir(1:1).NE.' ' ) CALL CVZREAD(Zfile)
      CURbas = LINbas(slot)
      LVNest = LVNest + 1
      IF ( LVNest.LE.MXNEST ) THEN
         LSUbpr(LVNest) = LEN(Zsub)
         ZSUbpr(LVNest)(1:LEN(Zsub)) = Zsub
         LFIlna(LVNest) = LEN(Zfile)
         ZFIlna(LVNest)(1:LEN(Zfile)) = Zfile
         LINnum(LVNest) =-1
         OFFset(LVNest) = CURbas
      ELSE
         WRITE(LOGUNI,*) 'SBZENT - Nesting exceeds ' , MXNEST
         WRITE(LOGUNI,*)
         DO i = LVNest , 1 , -1
            WRITE(LOGUNI,*) ZSUbpr(i)(1:LSUbpr(i))
         ENDDO
      ENDIF
*-IF CLOCKS
*-      CALL CKZON(slot)
*-ENDIF
      END
 
      SUBROUTINE PRZEXI
C
C  called just before the program STOPs
C
      IMPLICIT NONE
      INCLUDE 'probes.prv'
      INTEGER i
 
      IF ( ZCVdir(1:1).NE.' ' ) CALL CVZWRITE
*-IF CLOCKS
*-      CALL CKZRPT
*-ENDIF
      WRITE(LOGUNI,*)
      WRITE(LOGUNI,*) 'Traceback at program exit'
      WRITE(LOGUNI,*)
      DO i = LVNest , 1 , -1
         WRITE(LOGUNI,*) ZSUbpr(i)(1:LSUbpr(i))
      ENDDO
      CLOSE(LOGUNI)
      END
 
      SUBROUTINE SBZEXI
C
C  called just before control is RETURNed from a sub-program to the
C  caller
C
      IMPLICIT NONE
      INCLUDE 'probes.prv'
 
*-IF CLOCKS
*-      CALL CKZOFF
*-ENDIF
      LVNest = LVNest - 1
      IF ( LVNest.LE.0 ) STOP 'SBZEXI - Invalid traceback'
      CURbas = OFFset(LVNest)
      END
 
      SUBROUTINE CKZINI
C
C  initialise timer routines
C
      IMPLICIT NONE
      INCLUDE 'probes.prv'
      INTEGER i
      DO i = 1 , MAXSUB
         NMCall(i) = 0
         CPUtot(i) = 0.0
         CPUcum(i) = 0.0
      ENDDO
      CALL CPZTIC(TINiti)
      TINiti = TINiti - 1
      END
 
      SUBROUTINE CKZON(Clock)
      IMPLICIT NONE
      INTEGER Clock
C=======================================================================
C  turn on clock number Clock
C=======================================================================
      INCLUDE 'probes.prv'
 
      INTEGER jclk , ctime
 
      CALL CPZTIC(ctime)
C
C  update clock arrays
C
      CLKnum(LVNest) = Clock
      TENtry(LVNest) = ctime
      TREtrn(LVNest) = ctime
      NMCall(Clock) = NMCall(Clock) + 1
      IF ( LVNest.GT.1 ) THEN
         jclk = CLKnum(LVNest-1)
         CPUtot(jclk) = CPUtot(jclk) + ctime - TREtrn(LVNest-1)
      ENDIF
      END
 
      SUBROUTINE CKZOFF
      IMPLICIT NONE
C
C  turn off clock that was most recently turned on. Clocks form a
C  LIFO (last in, first out) stack.
C
      INCLUDE 'probes.prv'
 
      INTEGER iclk
      INTEGER ctime
 
      CALL CPZTIC(ctime)
      iclk = CLKnum(LVNest)
      CPUtot(iclk) = CPUtot(iclk) + ctime - TREtrn(LVNest)
      CPUcum(iclk) = CPUcum(iclk) + ctime - TENtry(LVNest)
      IF ( LVNest.GT.1 ) TREtrn(LVNest-1) = ctime
      END
 
      SUBROUTINE CKZRPT
      IMPLICIT NONE
C
C  write summary of CPU usage for each clock
C
      INCLUDE 'probes.prv'
      INTEGER ctime
      REAL tfac
      INTEGER ipc1 , ipc2 , i , j , n1 , n2 , nctot , fch , lch
 
      DO i = 1 , LVNest
         CALL CKZOFF
      ENDDO
 
      nctot = 0
      CALL CPZTIC(ctime)
      tfac = 100.0/(ctime-TINiti)
      WRITE(LOGUNI,99001) CPUFAC*(ctime-TINiti)
      DO i = 1 , MAXSUB
         IF ( NMCall(i).GT.0 ) THEN
            nctot = nctot + NMCall(i)
            ipc1 = CPUtot(i)*tfac + 0.5
            ipc2 = CPUcum(i)*tfac + 0.5
            IF ( ipc2.GE.1 ) THEN
               n1 = (ipc1+1)/2
               n2 = (ipc2+1)/2
               fch = FCSnam(i)
               lch = fch + LNSnam(i) - 1
               WRITE(LOGUNI,99000) ZBFsub(fch:lch) , NMCall(i) ,
     &                             ' calls ', ipc1 , '% ',
     &                             ('*',j=1,n1) , ('-',j=n1+1,n2)
            ENDIF
         ENDIF
      ENDDO
      WRITE(LOGUNI,*)
      WRITE(LOGUNI,*) '(* excludes called routines, - includes them)'
      WRITE(LOGUNI,*) nctot , ' Intervals timed'
 
99000 FORMAT(1X,A8,I8,A,I3,100A)
99001 FORMAT(/'  ------------------------------------------------'
     &       /' |                 Timing Reports                 |'
     &       /' |     Job completed after ',F10.2 ,' seconds     |'
     &       /' |    Routines taking >1% of total shown below    |'
     &       /'  ------------------------------------------------'/)
      END
 
      SUBROUTINE CPZTIC(Ntick)
      IMPLICIT NONE
C
C  returns CPU time as an integer - corresponding to the number of "ticks"
C  The PARAMETER CPUFAC in probes.prv converts ticks to seconds
C
      INTEGER Ntick
      INCLUDE 'probes.prv'
*-IF SALFORD
*-IF DOSINT
*-      CALL COPY_FROM_REAL_MODE1@(Ntick,4,1132)
*-ELSE
*-      REAL secs
*-      CALL CLOCK@(secs)
*-      Ntick = 1000*secs
*-ENDIF
*-ELSEIF MICROSOFT
*-ELSEIF VAXVMS
*-      INTEGER libZinit_timer , libZstat_timer , ios
*-      LOGICAL q1st
*-      SAVE q1st
*-      DATA q1st/.TRUE./
*- 
*-      IF ( q1st ) THEN
*-         ios = libZinit_timer()
*-         q1st = .FALSE.
*-      ENDIF
*-      ios = libZstat_timer(2,Ntick)
*-ELSEIF RS6K
*-      REAL etime_ , tarray(2)
*-      Ntick = 1000*etime_(tarray)
*-ELSEIF UNIX
      REAL etime , tarray(2)
      Ntick = 1000*etime(tarray)
*-ENDIF
      END
 
      SUBROUTINE CVZINIT
      IMPLICIT NONE
      INCLUDE 'probes.prv'
C***********************************************************************
C  Initialise coverage data
C***********************************************************************
      INTEGER i
 
      TOPlin = 0
      TOPbfs = 0
      TOPbff = 0
      NSList = 0
      CURbas = 999999
      DO i = 1 , MAXSUB
         FCSnam(i) = 0
         LNSnam(i) = 0
         LINbas(i) = 0
      ENDDO
      DO i = 1 , MAXLIN
         TCOunt(i) = -1
      ENDDO
      END
 
      SUBROUTINE CVZSLOT(Zsub,Slot,Qnew)
      IMPLICIT NONE
      CHARACTER*(*) Zsub
      INTEGER Slot
      LOGICAL Qnew
C***********************************************************************
C  Compute slot number from name by hashing.  This involves generating 
C  a pseudo-random number (or hash-code) from the name.  The hash code 
C  takes a value between 1 and MAXSUB, and is used to index the array of 
C  slots. In most cases different names produce different hash codes, 
C  making it easy to locate a particular name without searching.  
C  However, we must deal with collisions (cases where 2 names produce 
C  the same hash code).  This is done by searching through the slot 
C  array until the required name, or an empty slot is found.  The search 
C  starts at the hash code and proceeds with a stride calculated to 
C  minimise secondary collisions while ensuring that every element of 
C  the array is accessible. 
C
C  Qnew is set .TRUE. if this is the name has not been used before
C***********************************************************************
      INCLUDE 'probes.prv'
 
      INTEGER i , try , lsub , inc
 
      Qnew = .FALSE.
C
C  (1)  generate hash code. Efficiency is vital here.
C
      lsub = LEN(Zsub)
      Slot = -11
      DO i = 1 , lsub
C
C  Alternative hashing algorithms
C    1st is slower but more random - better when slots start filling up
C
C        Slot = Slot + (i+10)*ICHAR(Zsub(i:i))
         Slot = Slot + Slot + ICHAR(Zsub(i:i))
      ENDDO
      Slot = MOD(ABS(Slot),MAXSUB) + 1
C
C  (2)  check whether there is a collision
C
      DO try = 1 , MAXSUB
         IF ( LNSnam(Slot).EQ.lsub ) THEN
            IF ( ZBFsub(FCSnam(Slot):FCSnam(Slot)+lsub-1).EQ.Zsub )
     &                            GOTO 99999
         ELSEIF ( LNSnam(Slot).EQ.0 ) THEN
C
C  empty slot found - no collision.  This must be the first time the 
C  subprogram has been used - initialise the slot array elements.
C
            Qnew = .TRUE.
            IF ( TOPbfs+lsub.GT.BUFSIZ )
     &                   STOP 'Profiler - File list too long'
            FCSnam(Slot) = TOPbfs + 1
            LNSnam(Slot) = lsub
            TOPbfs = TOPbfs + lsub
            ZBFsub(FCSnam(Slot):TOPbfs) = Zsub
            GOTO 99999
         ENDIF
C
C  COLLISION! - get increment s.t. every slot is searched
C
         IF ( try.EQ.1 ) THEN
            IF ( Slot.LT.MAXSUB ) THEN
               inc = Slot
            ELSE
               inc = 13
            ENDIF
         ENDIF
C
C  ..and increment Slot
C
         Slot = MOD(Slot-1+inc,MAXSUB) + 1
      ENDDO
C
C  we should only get here if every element in the slot array is in use
C
      STOP 'Profiler Slot Overflow'
99999 RETURN
      END
 
      SUBROUTINE CVZREAD(Zfile)
      IMPLICIT NONE
      CHARACTER*(*) Zfile
C***********************************************************************
C  CVZREAD reads usage data from the .cvr file
C***********************************************************************
      INCLUDE 'probes.prv'
 
      INTEGER lsub , lfil , ptop , ios , lnum , slot
      DOUBLE PRECISION count
      LOGICAL qnew
      CHARACTER*80 zline , zsub , zfil
C
C  and read from file
C
      ptop = TOPlin
      CALL CVZOPEN(Zfile)
      DO WHILE ( .TRUE. ) 
         READ(COVUNI,'(A)',IOSTAT=ios) zline
         IF ( ios.NE.0 ) GOTO 200
         IF ( zline(1:4).EQ.'****' ) THEN
            zsub = zline(5:)
            lsub = INDEX(zsub,' ') - 1
            zfil = zsub(lsub+2:)
            lfil = INDEX(zfil,' ') - 1
            READ(zfil(lfil+2:),'(BN,I8)') lnum
            CALL CVZSLOT(zsub(1:lsub),slot,qnew)
            LINbas(slot) = ptop
            NSList = NSList + 1
            SLList(NSList) = slot
            count = MRKSUB
         ELSE
            READ(zline,'(I8,F15.0)',IOSTAT=ios) lnum , count
         ENDIF
         TOPlin = ptop + lnum
         IF ( TOPlin.GT.MAXLIN )
     &                 STOP 'Profiler - Total line limit exceeded'
         TCOunt(TOPlin) = count
      ENDDO
 200  CLOSE(COVUNI,IOSTAT=ios)
      ZBFfil(TOPbff+1:TOPbff+1+LEN(Zfile)) = Zfile
      TOPbff = TOPbff + LEN(Zfile) + 1
C
C  put "end of a file" marker (MRKEOF) in TCOunt
C
      TOPlin = TOPlin + 1
      IF ( TOPlin.GT.MAXLIN )
     &                    STOP 'Profiler - Total line limit exceeded'
      TCOunt(TOPlin) = MRKEOF
      RETURN
      END
 
      SUBROUTINE CVZWRITE
      IMPLICIT NONE
      INCLUDE 'probes.prv'
C***********************************************************************
C  Write updated .cvr files at end of run.
C***********************************************************************
      INTEGER j , ios , fch , lch , slot , slnum , base , pbuf , lfile
      DOUBLE PRECISION count
      CHARACTER zfile*(LNFILE) , z8*8
      pbuf = 1
      slnum = 0
      DO WHILE ( slnum.LT.NSList )
         DO j = pbuf , BUFSIZ
            IF ( ZBFfil(j:j).EQ.' ' ) GOTO 10
         ENDDO
         STOP 'File buffer overrun'
 10      lfile = j - pbuf
         zfile(1:lfile) = ZBFfil(pbuf:j-1)
         CALL CVZOPEN(zfile(1:lfile))
         pbuf = j + 1
         base = LINbas(SLList(slnum+1))
        
         DO j = 1 , MAXLIN
            count = TCOunt(base+j)
            IF ( count.GT.-0.5 ) THEN
               WRITE(COVUNI,'(I8,F15.0)',IOSTAT=ios) j , count
            ELSEIF ( ABS(count-MRKSUB).LT.0.1 ) THEN
               slnum = slnum + 1
               slot = SLList(slnum)
               fch = FCSnam(slot)
               lch = fch + LNSnam(slot) - 1
               WRITE(z8,'(I8)',IOSTAT=ios) j
               WRITE(COVUNI,'(5A)',IOSTAT=ios) '****' ,
     &                   ZBFsub(fch:lch) , ' ' , zfile(1:lfile) , z8
            ELSEIF ( ABS(count-MRKEOF).LT.0.1 ) THEN
               GOTO 100
            ENDIF
         ENDDO
 100     CLOSE(COVUNI,IOSTAT=ios)
      ENDDO
      END
 
      SUBROUTINE CVZOPEN(Zfile)
      IMPLICIT NONE
      CHARACTER*(*) Zfile
      INCLUDE 'probes.prv'
C***********************************************************************
C  Open coverage data file corresponding to Zfile
C***********************************************************************
      CHARACTER*256 zcvr
      INTEGER i , ios , ifnam , ilnam , ltot
C
C  get first and last characters (ifnam and ilnam) of name (excluding 
C  path and extension from Zfile
C
      ifnam = 1
      ilnam = LEN(Zfile)
      DO i = 1 , LEN(Zfile)
         IF ( INDEX(':\/[]',Zfile(i:i)).GT.0 ) THEN
            ifnam = i + 1
            ilnam = LEN(Zfile)
         ELSEIF ( Zfile(i:i).EQ.'.' ) THEN
            ilnam = i - 1
         ENDIF
      ENDDO
C
C  construct coverage data file name using directory ZCVdir, name from
C  zfile, and extension '.cvr'
C
      DO i = 1 , LEN(ZCVdir)
         IF ( ZCVdir(i:i).EQ.' ' ) GOTO 10
      ENDDO
 10   zcvr = ZCVdir(1:i)
      zcvr(i:i+ilnam-ifnam) = Zfile(ifnam:ilnam)
      zcvr(i+ilnam-ifnam+1:) = '.cvr'
      ltot = i+ilnam-ifnam+4
      
      OPEN(COVUNI,FILE=zcvr(1:ltot),STATUS='OLD',IOSTAT=ios)
      IF ( ios.NE.0 ) THEN
         PRINT * , zcvr(1:ltot)
         STOP 'Unable to open coverage data file'
      ENDIF
      END
 
      SUBROUTINE BLZENT(Lnum)
      IMPLICIT NONE
      INTEGER Lnum
C***********************************************************************
C  Increment counter for line Lnum in current file
C***********************************************************************
      INCLUDE 'probes.prv'
C
C  To use double precision counters (to avoid possible integer overflow 
C  when execution counts reach 2 billion) change TCOunt to
C  DOUBLE PRECISION in probes.prv
C
      TCOunt(CURbas+Lnum) = TCOunt(CURbas+Lnum) + 1
      END
